;;-------------------------------------------------------------------
;;
;; Lysa mode
;;
;; Adapted from René Rydhof Hansen's carmel-mode.el 
;; by Mikael Buchholtz
;;
;;-------------------------------------------------------------------


;;-------------------------------------------------------------------
;; lysa-mode
;;-------------------------------------------------------------------

(defun lysa-mode()
  "Simple LySa font locking mode."
  (interactive)
  (text-mode)				; Basically text mode
  (auto-fill-mode -1)
  (setq major-mode 'lysa-mode)
  (setq mode-name "LySa")
;  (use-local-map carmel-mode-map)
;  (set (make-variable-buffer-local 'comment-start) "-- ")
;  (set (make-variable-buffer-local 'comment-start-skip) "-- *")
;  (set (make-variable-buffer-local 'comment-end) "")
  (set (make-local-variable 'font-lock-defaults) lysa-font-lock-defaults)
;  (run-hooks 'carmel-mode-hook)

;  (local-set-key "\C-c\C-s" (progn (cd "/home/mib/src/lysa/")
;				   (sml-load-file "/home/mib/src/lysa/runhtml.sml")
;				   ))
;  (local-set-key "\C-c\C-b" (progn ())

)




;;-------------------------------------------------------------------
;; Font Lock [ \t]*/\*\(.\)*\*/
;;-------------------------------------------------------------------

(defconst lysa-font-lock-keywords
  '(;("[ \t]*/\*\\(.\\|\n\\)*\*/" . font-lock-comment-face)            
    ("[ \t]*/\*\\(.\\)*\*/" . font-lock-comment-face)            
    ("\\<\\(as\\|at\\|in\\|decrypt\\|dest\\|let\\|new\\|orig\\|subset\\)\\>" . font-lock-keyword-face)
    ("[ \t]*\\[\\([^]]\\|\n\\)**\\]" 0 font-lock-doc-face keep)
    ("\\([a-zA-Z][a-zA-Z0-9]*\\)\\(+\\|-\\)?\\([ \t\n]*_[ \t\n]*{[^}]*}\\)?" . font-lock-variable-name-face)
    )
  "lysa-mode font face keywords.")

(defconst lysa-font-lock-defaults
  '(lysa-font-lock-keywords		; The keywords
    nil					; Want fontification of strings etc.
    nil					; No case folding
    nil					; No syntax alist
    nil)				; No syntax begin
  "lysa-mode font lock defaults.")
