(*****************************************************************************)
(* Run analysis on a file and produce HTML output.                           *)
(*                                 Time-stamp: <28-01-2005 Mikael Buchholtz> *)
(*                                                                           *)
(* run(filename)        runs the analysis on the Lysa process in the file    *)
(*                      filename and produces HTML output in a file where    *)
(*                      the suffix of filename has been replaced with        *)
(*                      .html                                                *)
(*                                                                           *)
(* runp(filename,param) as run(filename) but with specific parameters given  *)
(*                      in param                                             *)
(*                                                                           *)
(*****************************************************************************)

SMLofNJ.Internals.GC.messages(false);

CM.make();

fun runp(filename, param) =
    let	val M      = LysaASCIIIO.parseFile (filename)	
	
	val ss     = FormulaAnalyzer.init() 
	val _      = FormulaAnalyzer.solve(ss,FormulaAnalyzer.
						  inputStr(Analysis2.
						       generate param M))
	val result = FormulaAnalyzer.outputData ss ([],false)

	val {base,ext} = OS.Path.splitBaseExt filename
    in
        (LysaHTMLIO.toHTML base M param result)
    end

	handle (LysaASCIIIO.parseError s) => (TextIO.print (s^"\n");())


fun run(name) = runp(name,Analysis2.default)
