(********************************************************************)
(* Naive set  implementation

   Partially adapted from implementation by Hanne Riis Nielson.
                          Time-stamp: <27-01-2005 Mikael Buchholtz> *)
(********************************************************************)


structure Set =
struct

fun isMember (x,xs)  = isSome (List.find (fn y => (x=y)) xs)
		       
fun mk_set (x::xs)   = if isMember (x,xs) 
		       then mk_set xs 
		       else x::(mk_set xs)
  |  mk_set []       = []

			
fun union (x,y)      = mk_set (x@y)

fun unionList xss    = mk_set (List.concat xss)

fun difference (xs,ys)  =  
    let fun del_elem (y,xs)  = List.filter (fn x => not(x=y)) xs;
	    fun del_list (y::ys,xs) = del_elem (y,del_list (ys,xs))
	      |  del_list ([],xs)    = xs
    in del_list (xs,ys)
    end
end